## com.saxonica.extra
Class IndexedFilterExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          com.saxonica.extra.IndexedFilterExpression

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

    public final class IndexedFilterExpression

extends Expression

An IndexedFilterExpression contains a base expression and a filter predicate. The base expression will always be a local variable reference. The filter will always be a Comparison, and it will have no positional dependencies

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`IndexedFilterExpression(VariableReference start, ComparisonExpression filter, boolean indexFirstOperand)` Constructor

Method Summary
`int` `computeCardinality()` Get the static cardinality of this expression
`int` `computeDependencies()` Determine which aspects of the context the expression depends on.
`int` `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`void` `display(int level, PrintStream out, Configuration config)` Diagnostic print of expression structure
`boolean` `equals(Object other)` Is this expression the same as another expression?
`Expression` `getBaseExpression()` Get the underlying expression
`ComparisonExpression` `getFilter()` Get the filter expression
`ItemType` `getItemType(TypeHierarchy th)` Get the data type of the items returned
`Expression` `getSearchExpression()` Get the expression to be searched
`Expression` `getUseExpression()` Get the expression to be indexed
`int` `hashCode()` get HashCode for comparing two expressions
`SequenceIterator` `iterate(XPathContext context)` Iterate over the results, returning them in the correct order
`Iterator` `iterateSubExpressions()` Get the immediate subexpressions of this expression
`Expression` `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` `promote(PromotionOffer offer)` Promote this expression if possible
`boolean` `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`Expression` `simplify(StaticContext env)` Simplify an expression
`Expression` `typeCheck(StaticContext env, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.Expression

`adoptChildExpression, checkPermittedContents, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### IndexedFilterExpression

    public IndexedFilterExpression(VariableReference start,
                                   ComparisonExpression filter,
                                   boolean indexFirstOperand)

  Constructor

  Parameters:
    `start` - A node-set expression denoting the absolute or relative set of nodes from which the navigation path should start.
    `filter` - An expression defining the filter predicate

Method Detail

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the data type of the items returned

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` -
  Returns:
    an integer representing the data type

### getBaseExpression

    public Expression getBaseExpression()

  Get the underlying expression

  Returns:
    the expression being filtered

### getFilter

    public ComparisonExpression getFilter()

  Get the filter expression

  Returns:
    the expression acting as the filter predicate

### getUseExpression

    public Expression getUseExpression()

  Get the expression to be indexed

### getSearchExpression

    public Expression getSearchExpression()

  Get the expression to be searched

### simplify

    public Expression simplify(StaticContext env)

  Simplify an expression

  Overrides:
    `simplify` in class `Expression`
  Returns:
    the simplified expression

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)

  Type-check the expression

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `env` - the static context
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the expression after type-checking (potentially modified to add run-time checks and/or conversions)

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution

### promote

    public Expression promote(PromotionOffer offer)
                       throws XPathException

  Promote this expression if possible

  Overrides:
    `promote` in class `Expression`
  Parameters:
    `offer` - details of the promotion that is possible
  Returns:
    the promoted expression (or the original expression, unchanged)
  Throws:
    `XPathException` - if any error is detected

### iterateSubExpressions

    public Iterator iterateSubExpressions()

  Get the immediate subexpressions of this expression

  Overrides:
    `iterateSubExpressions` in class `Expression`
  Returns:
    the subexpressions, as an array

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Specified by:
    `replaceSubExpression` in interface `Container`
  Overrides:
    `replaceSubExpression` in class `Expression`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### computeCardinality

    public int computeCardinality()

  Get the static cardinality of this expression

  Returns:
    the cardinality. The method attempts to determine the case where the filter predicate is guaranteed to select at most one item from the sequence being filtered

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-significant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `Expression`
  Returns:
    the static properties of the expression, as a bit-significant value

### equals

    public boolean equals(Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `Object`
  Parameters:
    `other` - the expression to be compared with this one
  Returns:
    true if the two expressions are statically equivalent

### hashCode

    public int hashCode()

  get HashCode for comparing two expressions

  Overrides:
    `hashCode` in class `Object`
  Returns:
    the hash code

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Iterate over the results, returning them in the correct order

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - the dynamic context for the evaluation
  Returns:
    an iterator over the expression results
  Throws:
    `XPathException` - if any dynamic error occurs

### computeDependencies

    public int computeDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE

  Overrides:
    `computeDependencies` in class `Expression`
  Returns:
    the dependencies

### display

    public void display(int level,
                        PrintStream out,
                        Configuration config)

  Diagnostic print of expression structure

  Specified by:
    `display` in class `Expression`
  Parameters:
    `level` - the indentation level
    `out` -
    `config` -

Copyright (C) Michael H. Kay. All rights reserved.